/*
 * Sub.h
 *
 * Copyright (C) 2007 Amos Brocco
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * You should have received a copy of the GNU General Public License
 * (for example COPYING); if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef SUB_H_
#define SUB_H_

#include <glib-object.h>
#include <glib.h>
#include "Base.h"

// /////////////////////////////////////////////////////////////////////////////////////////////////
// PRIVATE STRUCTURE PROTOTYPE
// /////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _SubPrivate SubPrivate;

// /////////////////////////////////////////////////////////////////////////////////////////////////
// INSTANCE STRUCTURE
// /////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _Sub {
	Base parent_instance;

        /* Pointer to private data structure */
	SubPrivate* priv;
} Sub;

// /////////////////////////////////////////////////////////////////////////////////////////////////
// CLASS STRUCTURE
// /////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _SubClass {
	BaseClass parent_class;

} SubClass;

// /////////////////////////////////////////////////////////////////////////////////////////////////
// GTYPE BOILERPLATE
// /////////////////////////////////////////////////////////////////////////////////////////////////

#define TYPE_SUB	 	(sub_get_type())
#define SUB(object)	        (G_TYPE_CHECK_INSTANCE_CAST((object), TYPE_SUB, Sub))
#define SUB_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST((klass), TYPE_SUB, SubClass))
#define IS_SUB(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), TYPE_SUB))
#define IS_SUB_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), TYPE_SUB))
#define SUB_GET_CLASS(object)	(G_TYPE_INSTANCE_GET_CLASS((object), TYPE_SUB, SubClass))
#define SUB_GET_PRIVATE(o)	(G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SUB, SubPrivate))

// /////////////////////////////////////////////////////////////////////////////////////////////////
// PUBLIC METHODS PROTOTYPES
// /////////////////////////////////////////////////////////////////////////////////////////////////

#endif /*SUB_H_*/

